<?php
namespace Teknisa\FIS\Controllers;

use Teknisa\FIS\Services\Fis22000PreValidacaoDeclaracoesAcessoriasService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;


class Fis22000PreValidacaoDeclaracoesAcessoriasController extends \Teknisa\FIS\Controllers\TeknisaCrud{

    protected $dataSourceName;
    protected $parameterBag;
    protected $crudService;
    protected $dataSourceNameToSave  = false;
    protected $service;

    public function __construct($crudService, ParameterBag $parameterBag, Fis22000PreValidacaoDeclaracoesAcessoriasService $service) {
        $this->service = $service;
        parent::__construct($crudService, $parameterBag);
    }
    


    public function validarNF(DTO\Request $request, DTO\Response $response) {
        try {
            set_time_limit(14400);
            $row = $request->getRow();
            $resul = $this->service->validarNF($row);
            $response->addDataSet(new DataSet("resul", $resul));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

}
