<?php

namespace Teknisa\FIS\Factories;

use Doctrine\ORM\EntityManager;

class Fis27100RelacionamentodeCodigodaReceitaFactory {
    
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function save($row){
      //  var_dump($row);die;
        $sql = "INSERT INTO RELACCODRECPART (NRORG, NRSEQCDRECPART, IDTIPO, CDFORNECED, CDCLIENTE, CDFILIAL, CDIMPOSTO, CDRECEITA) VALUES (:NRORG, :NRSEQCDRECPART, :IDTIPO, :CDFORNECED, :CDCLIENTE, :CDFILIAL, :CDIMPOSTO, :CDRECEITA)";
        $std = $this->connection->prepare($sql);
        $std->execute($row);
    }
    
    public function saveimposto($row){
      //  var_dump($row);die;
        $sql = "INSERT INTO RELACCODRECIMP (CDIMPOSTO, CDRECEITA , NRORG) VALUES (:CDIMPOSTO, :CDRECEITA, :NRORG)";
        $std = $this->connection->prepare($sql);
        $std->execute($row);
    }
    
    public function updateimposto($row){
      //  var_dump($row);die;
        $sql = "UPDATE RELACCODRECIMP SET CDRECEITA = :CDRECEITA WHERE CDIMPOSTO = :CDIMPOSTO";
        $std = $this->connection->prepare($sql);
        $std->execute($row);
    }
    
    public function buscaFornecedor ($row){
        $sql = "SELECT * FROM RELACCODRECPART WHERE CDFORNECED = :CDFORNECED";

        $params = array(
            'CDFORNECED'=>$row
            );
        $std = $this->connection->prepare($sql);
        $std->execute($params);
         #fetch all result rows and returns
        return $std->fetchAll();
    }
    
     public function buscaCliente ($row){
        $sql = "SELECT * FROM RELACCODRECPART WHERE CDCLIENTE = :CDCLIENTE";

        $params = array(
            'CDCLIENTE'=>$row
            );
        $std = $this->connection->prepare($sql);
        $std->execute($params);
         #fetch all result rows and returns
        return $std->fetchAll();
    }
    
     public function buscaFilial ($row){
        $sql = "SELECT * FROM RELACCODRECPART WHERE CDFILIAL = :CDFILIAL";

        $params = array(
            'CDFILIAL'=>$row
            );
        $std = $this->connection->prepare($sql);
        $std->execute($params);
         #fetch all result rows and returns
        return $std->fetchAll();
    }
}