/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_REGIAOPED                                                */
/* Tabela : REGIAOPED                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_REGIAOPED' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_REGIAOPED
GO

CREATE TRIGGER DTULTATU_REGIAOPED
ON REGIAOPED
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'REGIAOPED', null, 'CDREGIAOPED='+ CDREGIAOPED + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE REGIAOPED
      SET DTULTATURPED = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(REGIAOPED.CDREGIAOPED,0) = ISNULL(INSERTED.CDREGIAOPED,0)) AND
            (ISNULL(REGIAOPED.NMREGIAOPED,0) = ISNULL(INSERTED.NMREGIAOPED,0));
   END;
END;
GO