var Fis75000_Efd_Reinf_Controller = function(ScreenService, templateManager, Messages_fiscal, Fis75000_Efd_Reinf_Service, General, ZhFilterPreferences, Fis55000_ParametrizacaoExportacaoMunicipal_Controller) {
    
    var self = this;
    
    var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
    
    //Variavél que auxilia-ra nos processos com os parametros cadastrados
    var parametrosReinf = {};
    
    var cdempresaEnvio = "";
     
    // Nomes dos Eventos
    this.R1000 = Fis75000_Efd_Reinf_Service.R1000;
    this.R1070 = Fis75000_Efd_Reinf_Service.R1070;
    this.R2010 = Fis75000_Efd_Reinf_Service.R2010;
    this.R2020 = Fis75000_Efd_Reinf_Service.R2020;
    this.R2040 = Fis75000_Efd_Reinf_Service.R2040;
    this.R2055 = Fis75000_Efd_Reinf_Service.R2055;
    this.R2060 = Fis75000_Efd_Reinf_Service.R2060;
    this.R2098 = Fis75000_Efd_Reinf_Service.R2098;
    this.R2099 = Fis75000_Efd_Reinf_Service.R2099;
    this.R5001 = Fis75000_Efd_Reinf_Service.R5001;
    this.R5011 = Fis75000_Efd_Reinf_Service.R5011;
    this.R9000 = Fis75000_Efd_Reinf_Service.R9000;
    
    //Tipos de ambiente
    this.PRODUCAO = Fis75000_Efd_Reinf_Service.ID_AMBIENTE_PRODUCAO;
    this.PRODRESTRITA = Fis75000_Efd_Reinf_Service.ID_AMBIENTE_PRODRESTRITA;
    
    this.openFilterEventos = function(widget){
        var rowsToSet = {};
        rowsToSet.IDSTATUS = ["P", "E", "M", "R"];
        var CDEMPRESA = templateManager.container.getWidget('widgetEmpresa').currentRow.CDEMPRESA;
        if((cdempresaEnvio == "") || cdempresaEnvio != CDEMPRESA){
            ZhFilterPreferences.openFilterWidget(templateManager.container.getWidget('widgetEnvioEventos'), rowsToSet);
            cdempresaEnvio = CDEMPRESA;
        }
    };
    
    this.salvarEvento  = function (widget) {
        if(widget.isValid()){
            // Realiza algumas validações antes de salvar eventos
            //Fis75000_Efd_Reinf_Service.vericaEvento(widget.currentRow); 
            
            if (widget.currentRow.NMEVENTO === this.R9000) {
                widget.currentRow.__new_code_column_size = widget.currentRow.NRENVIOEXCLUSAO[0].toString().length;
            }
            General.callRestEngine('fis_acessorias#/salvarEvento','Row', widget.currentRow).then(
                function (response)  {
                    widget.activate();
                    if (widget.currentRow.__is_new) {
                        widget.list(true);
                        ScreenService.goBack();
                        widget.reload();
                    } else {
                        widget.computeDescriptionOrder();
                        widget.view();
                    }
                    if(response.messages[0].message)
                        ScreenService.showMessage(response.messages[0].message);
                        
                    if(widget.currentRow.NMEVENTO == 'R-2010' || widget.currentRow.NMEVENTO == 'R-2020') {
                        widget.currentRow.DTINICIAL     = widget.currentRow.DTMESCOMPETENC;
                        widget.currentRow.NOVOEVENTO    = true;
                        this.controlaWidgetItemsSemParam(widget);
                    }
                    if(widget.currentRow.NMEVENTO == 'R-2040' || widget.currentRow.NMEVENTO == 'R-2055') {
                        widget.currentRow.DTINICIAL     = widget.currentRow.DTMESCOMPETENC;
                        widget.currentRow.NOVOEVENTO    = true;
                    }
                }.bind(this),
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }.bind(this)  
            );    
            
        }
        widget.reload();
    };
    
    this.excluirMultEventos = function(widget) {
        var rows = widget.getCheckedRows();
        
        var naoPodeSerExcluido = rows.filter(function(row) {
            return !Fis75000_Efd_Reinf_Service.verificarPodeExcluir(row);
        }.bind(this));
        
        if (naoPodeSerExcluido.length > 0) {
            ScreenService.showMessage(Messages_fiscal.EVENTOS_NAO_PODE_SER_EXCLUIDO);
        } else {
            General.deleteCrudCheckedRows(widget);
        }
    };
    
    this.consultarEvento = function(widget, totalizador) {
        widget.currentRow.TOTALIZADOR = totalizador;
        widget.currentRow.IDOPERACAO = 'C';
        this.transmitirEvento(widget);
    };
    
    this.transmitirLoteEvento = function(widget) {
        if( Fis75000_Efd_Reinf_Service.validaTransmissaoLote(widget.getCheckedRows()) ) {
            widget.getCheckedRows()[0].NRINSJUREMPR  = widget.getParent().currentRow.NRINSJUREMPR.replace(/[^0-9]/g,'');
            widget.getCheckedRows()[0].IDTPIJUREMPR  = widget.getCheckedRows()[0].NRINSJUREMPR.length ===14 ?'1':'2';
            
            Fis75000_Efd_Reinf_Service.transmissao(widget.getCheckedRows()).then(
                function (response)  {
                    if (response.messages) {
                        var message = '';
                        response.messages.forEach(function(objMessage) {
                            message += objMessage.message + '<br>';
                        });
                        if (message) {
                            ScreenService.showMessage(message);
                        }
                    }
                    
                    var oldPage = widget.dataSource.getCurrentPage();
                    widget.dataSource.setCurrentPage(1);
                    widget.reload().then(function() {
                        widget.dataSource.setCurrentPage(oldPage); 
                        widget.unSelectAll();
                    });
                },
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );
        }
    };
    
    self.reenviarEventoVersao =  function(widget){
        var row = Util.clone(widget.currentRow, ignoredKeys);
        General.callRestEngine(
                'fis_acessorias#/paramempreinf', 
                'FilterData', 
                [
                    {
                        "name": "CDEMPRESA",
                        "operator": "=",
                        "value": row.CDEMPRESA
                    }
                ]
            ).then(function (success) {
                if(success.dataset.paramempreinf[0].CDVERSAO != widget.currentRow.DSVERSAO){
                    if (row.NMEVENTO == this.R1000) {
                        self.reenviarEvento(widget);
                    } else if (row.NMEVENTO == this.R2010 || row.NMEVENTO == this.R2020 || row.NMEVENTO == this.R2060) {
                        ScreenService.showCustomDialog('A versão atual difere da versão cadastrada neste envio de evento. Selecione a versão que deseja enviar.',
                            'CONFIRMATION',null,
                            [
                                {
                                    "label": "Versão 1.4",
                                    "code": function(){ 
                                        widget.currentRow.DSVERSAO = "1.4";
                                        self.reenviarEvento(widget);
                                    }
                                },
                                {
                                    "label": "Versão 1.05.01",
                                    "code": function(){ 
                                        widget.currentRow.DSVERSAO = "1.05.01";
                                        self.reenviarEvento(widget);
                                    }
                                }
                            ]
                        );
                    }
                } else {
                    self.reenviarEvento(widget);
                }
            }.bind(this));
    };
    
    this.reenviarEvento = function(widget) {
        var row = Util.clone(widget.currentRow, ignoredKeys);
        
        row.NRINSJUREMPR = widget.getParent().currentRow.NRINSJUREMPR.replace(/[^0-9]/g,'');
        row.IDTPIJUREMPR = row.NRINSJUREMPR.length ===14 ?'1':'2';
        
        if (row.NMEVENTO == this.R1000) {
            row.IDOPERACAO = 'A';
        } else if (row.NMEVENTO == this.R2010 || row.NMEVENTO == this.R2020 || row.NMEVENTO == this.R2060 || row.NMEVENTO == this.R2040 || row.NMEVENTO == this.R2055) {
            row.IDOPERACAO = 'R';   
        }
                    
        Fis75000_Efd_Reinf_Service.transmissao([row]).then(
            function (response)  {
                var message = '';
                response.messages.forEach(function(objMessage) {
                    message += objMessage.message + '<br>';
                });
                if (message) {
                    ScreenService.showMessage(message);
                }
                var oldPage = widget.dataSource.getCurrentPage();
                widget.dataSource.setCurrentPage(1);
                widget.reload().then(function() {
                    widget.dataSource.setCurrentPage(oldPage); 
                });
                this.controlaVisibilidadeAction(widget);
                widget.redraw(true);
            }.bind(this),
            function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            }  
        );
    };

    this.transmitirEvento = function(widget) {
        widget.currentRow.NRINSJUREMPR = widget.getParent().currentRow.NRINSJUREMPR.replace(/[^0-9]/g,'');
        widget.currentRow.IDTPIJUREMPR = widget.currentRow.NRINSJUREMPR.length === 14 ?'1':'2';
        
        Fis75000_Efd_Reinf_Service.transmissao([widget.currentRow]).then(
            function (response)  {
                var message = '';
                response.messages.forEach(function(objMessage) {
                    message += objMessage.message + '<br>';
                });
                if (message) {
                    ScreenService.showMessage(message);
                }
                
                if (response.dataset) {
                    if (response.dataset.report) {
                        var reportOpened = window.open(response.dataset.report.report_url);
			            if(!reportOpened){
			                ScreenService.showMessage(ScreenService.i18n('Pop-up Blocker is enabled! Please add this site to your exception list.'));
			            }
                    }
                }
                
                var oldPage = widget.dataSource.getCurrentPage();
                widget.dataSource.setCurrentPage(1);
                widget.reload().then(function() {
                    widget.dataSource.setCurrentPage(oldPage); 
                    this.controlaVisibilidadeAction(widget);
                    widget.redraw(true);
                }.bind(this));
            }.bind(this),
            function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            }  
        );
        widget.reload();
    };
    
    // Realiza os procedimentos para adicionar um evento;
    this.addEnvioEvento   = function (widget) {
        var cdempresa =  widget.getParent().currentRow.CDEMPRESA;
        General.callRestEngine('fis_acessorias#/getParametrosReinf','Row',widget.getParent().currentRow).then(
            function (response)  {
                var parametros  = response.dataset.parametros;
                var campoEvento = widget.getField('DSEVENTO'); 
                // Só é possivel adicionar registros caso exista a paramtrização para a empresa.
                if(parametros.length>0){
                    parametrosReinf = parametros;
                    widget.newRow();
                    campoEvento.dataSourceFilter = [
                        {
                            "name":"DSVERSAO",
                            "operator":"=",
                            "value" :parametros[0].CDVERSAO
                        },
                        {
                            "name": "NMEVENTO",
                            "operator": "IN",
                            "value": ["R-1000", "R-2010", "R-2020", "R-2040", "R-2055","R-2060", "R-2098", "R-2099", "R-9000"]
                        }
                    ];
                    
                    //Verifica parametro para ver se a empresa pode adicionar um evento R-2060
                    
                    if(parametros[0].IDINDCPRB == '1'){
                        campoEvento.dataSourceFilter[1].value.push("R-2060");
                    }
                    //Procedimetos para gerar novo código;
                    var paramsNewCode     = widget.paramsNewCode;
                    var keysParamsNewCode = Object.keys(paramsNewCode);
                    keysParamsNewCode.forEach(function(value) {
                        widget.currentRow[value] = paramsNewCode[value];
                    });
                    
                    widget.currentRow.IDAMBIENTE   = parametros[0].IDAMBIENTE;
                    widget.currentRow.DSVERSAO     = parametros[0].CDVERSAO;
                    widget.currentRow.CDEMPRESA    = cdempresa;
                    this.controlaCamposEventos(widget);
                    
                    widget.getField('DSEVENTO').reload();
                }
                else
                    ScreenService.showMessage(Messages_fiscal.PARAMETROS_REINF, 'error');
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            }  
        );
    };
    
    /*
        Função para recarregar dataSource de um field e 
        exibir uma mensagem caso esteja vazio.
    */
    this.recarrgarField = function (field, mensagem) {
        field.reload().then(
            function (response)  {
                if(field.dataSource.data.length === 0)
                    ScreenService.showMessage(mensagem);
                
            }    
        );
    };
    
    /*
        Realiza o controle de quais actions estarão visiveis
        dependendo do status do evento.
    */
    this.controlaVisibilidadeAction = function (widget) {
        var idstatus               = widget.currentRow.IDSTATUS;
        var evento                 = widget.currentRow.NMEVENTO;
        var envio                  = widget.currentRow.NRENVIO;
        var empresa                = widget.currentRow.CDEMPRESA;
        var ambiente               = widget.currentRow.IDAMBIENTE;
        var dtinicial              = widget.currentRow.DTINIVALIDADE;
        var dtfinal                = widget.currentRow.DTFINVALIDADE;
        var recibo                 = widget.currentRow.NRRECIBO;
        var actionExluirEvento     = widget.getAction('DELETAR');
        var actionTransmitirEvento = widget.getAction('transmitir');
        var actionReenvio          = widget.getAction('reenvio');  
        var actionConsulta         = widget.getAction('consultar');
        var actionConsultaTot      = widget.getAction('consultarTotalizador');
        var actionReportConsulta   = widget.getAction('REPORTCONSULTA');
        var actionViewXml          = widget.getAction('VIEWXML');
        
        actionExluirEvento.isVisible = Fis75000_Efd_Reinf_Service.verificarPodeExcluir(widget.currentRow); 
        var visibilidadeEnvio = (idstatus === 'P' || idstatus === 'E'); 
        actionConsultaTot.isVisible = (evento == this.R2099 && idstatus == 'M');
        actionReportConsulta.isVisible  = (evento == this.R2099 && (idstatus == 'C' || idstatus == 'R'));
        actionViewXml.isVisible         = (evento == this.R2099 && (idstatus == 'C' || idstatus == 'R'));

        
        // FIELDS GROUP - So mostra aberto caso o evento já tenha sido enviado.
        widget.fieldGroups.forEach(function(grupo) {
            grupo.opened = widget.currentRow.IDSTATUS != 'P';
        });
        
        if (evento == this.R1000 && (idstatus === 'C' || idstatus === 'M')) {
            General.callRestEngine(
                'fis_acessorias#/R1000_vigente', 
                'FilterData', 
                [{
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": empresa
                },{
                    "name": "AMBIENTE",
                    "operator": "=",
                    "value": ambiente
                },{
                    "name": "DTINICIAL",
                    "operator": "=",
                    "value": dtinicial
                },{
                    "name": "DTFINAL",
                    "operator": "=",
                    "value": dtfinal
                }]
            ).then(function (success) {
                var nrenvioBack = success.dataset.R1000_vigente.NRENVIO;
                actionReenvio.isVisible = nrenvioBack == envio;
                actionReenvio.label = 'Transmitir Alteração';
            });
        } else if (
            (evento == this.R2010 || evento == this.R2020 || evento == this.R2060 || evento == this.R2040 || evento == this.R2055) && 
            (idstatus == 'C' || (idstatus == 'E' && widget.currentRow.NRRECIBO))
        ) {
            actionReenvio.isVisible = true;
            actionReenvio.label = 'Transmitir Retificação';
            actionTransmitirEvento.isVisible = false;
        } else {
            actionReenvio.isVisible = false;
            actionTransmitirEvento.isVisible = visibilidadeEnvio;
        }
        
        if (
            (evento == this.R1000 || evento == this.R2010 || evento == this.R2020 || evento == this.R2040 || evento == this.R2055 || evento == this.R2060 || evento == this.R2098 || 
            (evento == this.R2099 && idstatus != 'M' && idstatus != 'R')) && (idstatus == 'P'  || idstatus == 'E' || (idstatus == 'C' && widget.currentRow.NRRECIBO))
        ){
            actionConsulta.isVisible = true;
        }
        
        if(recibo) {
            actionExluirEvento.isVisible = false;
        } else {
            actionExluirEvento.isVisible = true;
        }
        
     
    };
    
    this.openEFD = function(widget) {
        ScreenService.openWindow("fis_acessorias#fis75001_parametros_EFD_reinf").then(function() {
            var widgetEFD = templateManager.containers["fis_acessorias#fis75001_parametros_EFD_reinf"].getWidget('tabbedWidget');
            widgetEFD.currentRow.CDEMPRESA    = widget.currentRow.CDEMPRESA;
            widgetEFD.currentRow.NMEMPRESA    = widget.currentRow.NMEMPRESA;
            widgetEFD.currentRow.NRINSJUREMPR = widget.currentRow.NRINSJUREMPR.replace(/[^0-9]/g,'');
            this.atualizaTelaParametrizacao(widgetEFD.getField('CDEMPRESA'));
        }.bind(this));
    };
    
    this.atualizaTelaParametrizacao = function (field) {
        var widget = templateManager.containers["fis_acessorias#fis75001_parametros_EFD_reinf"].getWidget('fis75001_parametros_EFD_reinf_form');
        if (!Util.isEmptyOrBlank(field.value())){
            widget.reload().then(function (){
                var existeData = (widget.dataSource.data[0]) ? true : false;
                widget.currentRow = (existeData) ? widget.dataSource.data[0] : {};
                widget.currentRow.CDEMPRESA = field.value();
                widget.getField('DSDIRCERTIFICADO').fileList = widget.currentRow.DSDIRCERTIFICADO;
                widget.getAction('edit').isVisible = existeData;
                widget.getAction('edit').readOnly  = !existeData;
                widget.getAction('adicionar').isVisible = !existeData;
                widget.getAction('adicionar').readOnly  = existeData;
                widget.redraw();
            }, function (error){
                ScreenService.errorNotification(error);
                widget.getAction('edit').readOnly = false;
                widget.getAction('adicionar').readOnly = false;
                widget.redraw();
            });
        } else {
            widget.currentRow = {};
            widget.getAction('edit').isVisible = false;
            widget.getAction('edit').readOnly  = false;
            widget.getAction('adicionar').isVisible = true;
            widget.getAction('adicionar').readOnly = true;
            widget.redraw();
        }
    };
   
    this.onChangeEvento = function (widget) {
        this.controlaCamposEventos(widget);
        if(widget.currentRow.NMEVENTO === this.R1000){
            widget.currentRow.DTINIVALIDADE  = parametrosReinf[0].DTINIVALIDADE;
            widget.currentRow.DTFINVALIDADE  = parametrosReinf[0].DTFINVALIDADE; 
            widget.currentRow.DTMESCOMPETENC = null; 
        }else{
            widget.currentRow.DTINIVALIDADE = '';
            widget.currentRow.DTFINVALIDADE = '';
        }
        
        if (widget.currentRow.NMEVENTO  ===this.R1070){
            widget.currentRow.DTMESCOMPETENC = null; 
            widget.getField('NRPROCESSO').reload();
        }
        
        widget.currentRow.NRPROCESSO = null;
        widget.currentRow.CDPROCESSO = null;
        
        
        
    }; 
    
    /* Esse controle de tela foi separado em dois momentos 
    devido a problemas no zeedhi, que estava atrapalhando a 
    visibilidade de outros campos*/
    
    /*
        Realiza o Controle dos campos específicos de eventos,
        somente no momento de adicionar.
    */
    
    this.controlaCamposEventos = function (widget) {
        var nmenvento = widget.currentRow.NMEVENTO;
        
        //R1000
        var tipoOperacao     = widget.getField('IDOPERACAO');
        //R1000 e R1070 
        var dataInicial      = widget.getField('DTINIVALIDADE');
        var dataFinal        = widget.getField('DTFINVALIDADE');
        //R1070
        var nrprocesso       = widget.getField('NRPROCESSO');
        // Todos, exceto R1000 e R1070 e R9000
        var dataCompetencia  = widget.getField('DTMESCOMPETENC');
        //R9000
        var eventos  = widget.getField('NRENVIOEXCLUSAO');
        
        
        dataInicial.showOnForm      =  (widget.currentRow.NMEVENTO === this.R1000 || widget.currentRow.NMEVENTO === this.R1070);
        dataFinal.showOnForm        =  (widget.currentRow.NMEVENTO === this.R1000 || widget.currentRow.NMEVENTO === this.R1070);
        dataCompetencia.showOnForm  =  (widget.currentRow.NMEVENTO != this.R1000 &&
                                        widget.currentRow.NMEVENTO !=  this.R1070 &&
                                        widget.currentRow.NMEVENTO !=  this.R9000);
        nrprocesso.showOnForm       =  (widget.currentRow.NMEVENTO === this.R1070);
        eventos.showOnForm = (widget.currentRow.NMEVENTO === this.R9000);
        
        // Controle IDOPERACAO
        if (widget.currentRow.NMEVENTO !== this.R1000) {
            widget.currentRow.IDOPERACAO = nmenvento == this.R9000 ? 'E' : 'I';
            tipoOperacao.readOnly = true;
            tipoOperacao.showOnForm = false;
            delete tipoOperacao.validations.required;
        } else {
            tipoOperacao.readOnly = false;
            tipoOperacao.showOnForm = true;
            tipoOperacao.validations.required = true;
        }
        
        if(widget.currentRow.NMEVENTO === this.R1000 || 
            widget.currentRow.NMEVENTO === this.R1070){
                
            dataInicial.validations.required = true;
            delete(dataCompetencia.validations.required);
            delete eventos.validations.required;
            
            //Campo de Processo que somente está visível no evento R1070
            if(widget.currentRow.NMEVENTO === this.R1070)
                nrprocesso.validations.required = true;
            else
                delete(nrprocesso.validations.required);
        } else if (widget.currentRow.NMEVENTO === this.R9000) { 
            eventos.validations.required = true;
            delete dataCompetencia.validations.required;
            delete(dataInicial.validations.required);
            delete(nrprocesso.validations.required);
        } else { 
            dataCompetencia.validations.required = true;
            delete(dataInicial.validations.required);
            delete(nrprocesso.validations.required);
            delete eventos.validations.required;
        }
        
        widget.redraw(true);
    };
    
    /* 
        Controla a visibilidade de campos que são mostrados apenas 
        para determinado evento. No eventos de After Move Row, mas não
        incluindo o new row.
    */
    this.controleCamposEventosView = function (widget) {
        if(!widget.currentRow.__is_new){
            var dataInicial      = widget.getField('DTINIVALIDADE');
            var dataFinal        = widget.getField('DTFINVALIDADE');
            var dataCompetencia  = widget.getField('DTMESCOMPETENC');
            var dsestabreinf     =  widget.getField('DSESTABREINF');
            var nrprocesso       = widget.getField('NRPROCESSO');
        
            //************************ R1000 e R1070 *********************************/
            dataInicial.showOnView      =  (widget.currentRow.NMEVENTO === this.R1000 || widget.currentRow.NMEVENTO === this.R1070);
            dataFinal.showOnView        =  (widget.currentRow.NMEVENTO === this.R1000 || widget.currentRow.NMEVENTO === this.R1070);
            dataCompetencia.showOnView  =  ( widget.currentRow.NMEVENTO != this.R1000 && widget.currentRow.NMEVENTO != this.R1070);
          
            
            //************************ R1070 *****************************************/
            
            nrprocesso.showOnView      =  ( widget.currentRow.NMEVENTO === this.R1070);
            
            ///************************ R2010 & R2020 *******************************/
            // Define as máscaras de acordo com o tipo de inscrição
            var mascara                    = widget.currentRow.TIPOINSCRICAO ==='J'? '00.000.000/0000-00' : widget.currentRow.TIPOINSCRICAO ==='F'?'000.000.000-00':'';
            var isncricao                  = widget.currentRow.NMEVENTO === this.R2020 || widget.currentRow.NMEVENTO === this.R2010 ?  formataCampo(widget.currentRow.INCSESTABREINF,mascara) : widget.currentRow.INCSESTABREINF;
            
            dsestabreinf.showOnView        =  (widget.currentRow.NMEVENTO === this.R2020 || widget.currentRow.NMEVENTO === this.R2010);
            dsestabreinf.label             =  widget.currentRow.NMEVENTO === this.R2010? 'Tomador' : 'Prestador';
            widget.currentRow.DSESTABREINF =  isncricao +' - '+widget.currentRow.NMESTABREINF;
            
            widget.resizeGridColumns(true);
            widget.redraw();    
        }
    };
    
    
    //formata de forma generica os campos
    function formataCampo(campo, Mascara) { 
        var boleanoMascara; 
        var exp            = /\-|\.|\/|\(|\)| /g;
        var campoSoNumeros = campo.toString().replace( exp, "" ); 
        var posicaoCampo   = 0;    
        var NovoValorCampo = "";
        var TamanhoMascara = campoSoNumeros.length;
        
        for(var i=0; i<= TamanhoMascara; i++) { 
            boleanoMascara  = ((Mascara.charAt(i) == "-") || (Mascara.charAt(i) == ".")  || (Mascara.charAt(i) == "/")) ;
            boleanoMascara  = boleanoMascara || ((Mascara.charAt(i) == "(") || (Mascara.charAt(i) == ")") || (Mascara.charAt(i) == " ")); 
            if (boleanoMascara) { 
                NovoValorCampo += Mascara.charAt(i); 
                TamanhoMascara++;
            }else { 
                NovoValorCampo += campoSoNumeros.charAt(posicaoCampo); 
                posicaoCampo++; 
            }              
        }      
        return  NovoValorCampo;
    }
    
    /*
        Faz o controle para exibir a widget do detalhemtno do Envio, 
        que irá mostra informações referentes ao envio do evento.
    */
    this.controlaWidgetDetalhemntoEnvio = function(widget) {
        var widgetDetalhamentoEventoContrPrev       = widget.widgets[0];
        var widgetDetalhamentoEventoCPRB            = templateManager.container.getWidget('widgetDetalhamentoEventoCPRB');
        var widgetDetalhamentoEventoR2055            = templateManager.container.getWidget('widgetDetalhamentoEventoR2055');
        
        switch(widget.currentRow.NMEVENTO) {
            case this.R2010:
            case this.R2020:
                widgetDetalhamentoEventoContrPrev.isVisible = (widget.currentRow.NMEVENTO === this.R2020 || widget.currentRow.NMEVENTO === this.R2010);
                widgetDetalhamentoEventoCPRB.isVisible = false;
                
                if(widget.currentRow.NMEVENTO === this.R2020){
                    widgetDetalhamentoEventoContrPrev.dataSource.name ='fis_acessorias#/crud/detalhamentoEnvio_eventoR2020';
                }else{
                    widgetDetalhamentoEventoContrPrev.dataSource.name ='fis_acessorias#/crud/detalhamentoEnvio_eventoR2010';
                }
                widgetDetalhamentoEventoContrPrev.dataSourceFilter = [
                    {
                        "name": "CDPARTICIPANTE",
                        "operator": "=",
                        "value": widget.currentRow.CDESTABREINF
                    },
                    {
                        "name": "CDIMPOSTO",
                        "operator": "=",
                        "value": widget.currentRow.NMEVENTO === this.R2010 ?'41':'42'
                    },
                    {
                        "name": "CDEMPRESA",
                        "operator": "=",
                        "value": widget.currentRow.CDEMPRESA
                    },
                    {
                        "name": "DTINICIAL",
                        "operator": "=",
                        "value": moment(widget.currentRow.DTMESCOMPETENC,'DD/MM/YYYY').format('DD/MM/YYYY')
                    },
                    {
                        "name": "DTFINAL",
                        "operator": "=",
                        "value": moment(widget.currentRow.DTMESCOMPETENC,'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY')
                    }
                    
                ];
                widgetDetalhamentoEventoContrPrev.reload();
                break;
                
            case this.R2060:
                widgetDetalhamentoEventoContrPrev.isVisible = false;
                widgetDetalhamentoEventoCPRB.isVisible = true;
                
                General.callRestEngine('fis_acessorias#/detalhamentoR2060','Row',widget.currentRow).then(
                    function (success)  {
                        widgetDetalhamentoEventoCPRB.currentRow = success.dataset.detalhamentoR2060[0];
                        //widgetDetalhamentoEventoCPRB.reload();
                    },
                    function (callback) {
                        if (callback.data) {
                            ScreenService.showMessage(callback.data.error);
                        }
                    }  
                );
                break;
                
             case this.R2055:
                widgetDetalhamentoEventoR2055.isVisible = true; //widget.currentRow.NMEVENTO === this.R2055;
                widgetDetalhamentoEventoContrPrev.isVisible = false;
                widgetDetalhamentoEventoCPRB.isVisible = false;
                
                widgetDetalhamentoEventoR2055.dataSource.name ='fis_acessorias#/crud/detalhamentoEnvio_eventoR2055';
                widgetDetalhamentoEventoR2055.dataSourceFilter = [
                    {
                        "name": "CDPARTICIPANTE",
                        "operator": "=",
                        "value": widget.currentRow.CDESTABREINF
                    },
                    {
                        "name": "CDIMPOSTO",
                        "operator": "=",
                        "value": '26'
                    },
                    {
                        "name": "CDEMPRESA",
                        "operator": "=",
                        "value": widget.currentRow.CDEMPRESA
                    },
                    {
                        "name": "DTINICIAL",
                        "operator": "=",
                        "value": moment(widget.currentRow.DTMESCOMPETENC,'DD/MM/YYYY').format('DD/MM/YYYY')
                    },
                    {
                        "name": "DTFINAL",
                        "operator": "=",
                        "value": moment(widget.currentRow.DTMESCOMPETENC,'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY')
                    },
                    {
                        "name": "NRINSJURFILI",
                        "operator": "=",
                        "value": widget.currentRow.NRINSJURFILI
                    }
                    
                ];
                widgetDetalhamentoEventoR2055.reload();
                break;
            default:
                //widgetDetalhamentoEventoR2055.isVisible = false;
                widgetDetalhamentoEventoContrPrev.isVisible = false;
                widgetDetalhamentoEventoCPRB.isVisible = false;
        }
    };

    this.abreItemsNota = function(widget) {
        var swipe = templateManager.container.getWidget('itens');
        swipe.dataSourceFilter = [{
            "name": "NRLANCTONF",
            "operator": "=",
            "value": widget.currentRow.NRLANCTONF
        },{
            "name": "CDFILIAL",
            "operator": "=",
            "value": widget.currentRow.CDFILIAL
        },{
            "name": "CDIMPOSTO",
            "operator": "=",
            "value": widget.getParent().currentRow.NMEVENTO == this.R2010 ? '41' : '42'
        },{
            "name": "CDINSCMUNI",
            "operator": "=",
            "value": widget.currentRow.CDINSCMUNI
        },{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": widget.currentRow.CDEMPRESA
        }];
        
        ScreenService.openSwipe(swipe);
        swipe.reload();
    };
    
    this.visibilidadeR2055 = function(widget) {
        var widgetDetalhamentoEventoContrPrev       = widget.widgets[0];
        var widgetDetalhamentoEventoCPRB            = templateManager.container.getWidget('widgetDetalhamentoEventoCPRB');
        var widgetDetalhamentoEventoR2055            = templateManager.container.getWidget('widgetDetalhamentoEventoR2055');
        
    };
    /* Control de campos */
    this.regrasAlteracaoOperacao = function(widget) {
        if (widget.currentRow.NMEVENTO == this.R1000 && (widget.currentRow.IDOPERACAO != 'E' && widget.currentRow.IDOPERACAO != 'I')) {
            ScreenService.showMessage(Messages_fiscal.TIPO_OPERACAO_INVALIDA_PARA_R1000);
            widget.currentRow.IDOPERACAO = null;
        }
    };
    
    this.geraReport = function(widget) {
        var currentRow = widget.currentRow;
        var rowParent = widget.getParent().currentRow;
        
        if(currentRow.DSDIRXMLCONSULTA && currentRow.DSDIRXMLCONSULTA !== ""){
            var reportName = 'CONSULTAR2099';
            var params = {
                "EMPRESA": rowParent.CDEMPRESA+' - '+rowParent.NMEMPRESA,
                "PERIODO": moment(currentRow.DTMESCOMPETENC, 'DD/MM/YYYY').format('MM/YYYY'),
                "URL_XML": currentRow.DSDIRXMLCONSULTA
            };
            
            General.openReport('fis#/geraReportConsulta', reportName, params);  
        } else {
            widget.currentRow.IDSTATUS = 'M';
            widget.currentRow.NMSTATUS = 'Em Processamento';
            ScreenService.showMessage('Ocorreu um erro ao tentar gerar o relatório.');
            ScreenService.closePopup();
            ScreenService.closeSwipe();
        }
    };

    this.openXML  = function(widget) {
        if(widget.currentRow.DSDIRXMLCONSULTA && widget.currentRow.DSDIRXMLCONSULTA !== ""){    
            window.open("http://midia.teknisa.com/files/" + widget.currentRow.DSDIRXMLCONSULTA, "_blank");
        } else {
            widget.currentRow.IDSTATUS = 'M';
            widget.currentRow.NMSTATUS = 'Em Processamento';
            ScreenService.showMessage('Ocorreu um erro ao tentar gerar o relatório.');
            ScreenService.closePopup();
            ScreenService.closeSwipe();
        }
    };
    
    this.openFilterEnvio = function(widget) {
        ZhFilterPreferences.openFilterWidget(widget);
    };
    
    this.salvarParametrizacao = function(widget) {
        var row = widget.currentRow;
        row.__is_new = true;
        
        row.CDPRODUTO = row.CDPRODSERV;
        row.NMPRODUTO = row.DSPRODSERV;
        
        if(widget.isValid()) {
            
            if(row.ALLINSC == 'Y') {
                var save = {
                    INSCRICOES: ['T', {
                            "CDINSCMUNI" : 1,
                            "CDEMPRESA" : 1
                        }],
                    PRODUTOS: [row]
                };
                
                    
                Fis55000_ParametrizacaoExportacaoMunicipal_Controller.cadastroAutomatico(widget, 'NAOSOBREESCREVER', save);
                setTimeout(function() {
                    ScreenService.goBack();
                    widget.reload();
                    templateManager.container.getWidget('widgetDetalhamentoEventoContrPrev').reload();
                    templateManager.container.getWidget('widgetEnvioEventos').reload();
                }, 5000);
            } else if(widget.currentRow.IDENTRSAIDOP == 'T' ){
                        
                        widget.currentRow.IDENTRSAIDOP = 'S';
                            General.saveCrud(widget).then(function(success) {
                                ScreenService.showMessage('Registro salvo com sucesso.');
                            }, function(callback){
                                if(callback.data){
                                    ScreenService.showMessage(callback.data.error);
                                }
                            });
                        widget.currentRow.IDENTRSAIDOP = 'E';
                            // Salva Paramentros de Exportação Municipal
                            General.saveCrud(widget).then(function(success) {
                                ScreenService.showMessage('Registro salvo com sucesso.');
                            }, function(callback){
                                if(callback.data){
                                    ScreenService.showMessage(callback.data.error);
                                }
                            });
                            
                           
                    }else{
                        General.saveCrud(widget).then(function(success) {
                                ScreenService.showMessage('Registro salvo com sucesso.');
                            }, function(callback){
                                if(callback.data){
                                    ScreenService.showMessage(callback.data.error);
                                }
                            });
                    }
            
            
        }
        templateManager.container.getWidget('widgetDetalhamentoEventoContrPrev').reload();
        templateManager.container.getWidget('widgetEnvioEventos').reload();
        widget.reload();
        
    };
    
    this.controlaWidgetItemsSemParam = function(widget) {
        
        if(widget.currentRow.NMEVENTO === this.R2020 || widget.currentRow.NMEVENTO === this.R2010) {
            
            if(widget.currentRow.NOVOEVENTO) {
                widget.getParent().widgets[2].dataSourceFilter[2].value = widget.currentRow.NMEVENTO === this.R2010 ? '41' : '42';
                /*if(widget.currentRow.NMEVENTO === this.R2010){
                    widget.getParent().widgets[1].dataSourceFilter[4] =
                    {
                        "name": "CDFORNECED",
                        "operator": "=",
                        "value": widget.currentRow.CDESTABREINF
                    };
                } else if (widget.currentRow.NMEVENTO === this.R2020){
                    widget.getParent().widgets[1].dataSourceFilter[4] =
                    {
                        "name": "CDCLIENTE",
                        "operator": "=",
                        "value": widget.currentRow.CDESTABREINF
                    };
                }*/
                widget.getParent().widgets[2].dataSourceFilter.forEach(function(filter, index){
                    if(filter.name == 'CDFORNECED' || filter.name == 'CDCLIENTE'){
                       widget.getParent().widgets[2].dataSourceFilter.splice(index, 1); 
                    }
                });        
                widget.getParent().widgets[2].reload().then(function(data) {
                    if(data.dataset.itemsemparametrizacao[0]) {
                        widget.getParent().widgets[2].isVisible = true; 
                        widget.getParent().openTab(widget.getParent().widgets[1].name);
                    }
                    else  widget.getParent().widgets[2].isVisible = false; 
                });
                
            }
            else {
                widget.widgets[2].dataSourceFilter[2].value = widget.currentRow.NMEVENTO === this.R2010 ? '41' : '42';
                if(widget.currentRow.NMEVENTO === this.R2010){
                    widget.widgets[2].dataSourceFilter[4] =
                    {
                        "name": "CDFORNECED",
                        "operator": "=",
                        "value": widget.currentRow.CDESTABREINF
                    };
                } else if (widget.currentRow.NMEVENTO === this.R2020){
                    widget.widgets[2].dataSourceFilter[4] =
                    {
                        "name": "CDCLIENTE",
                        "operator": "=",
                        "value": widget.currentRow.CDESTABREINF
                    };
                }
                widget.widgets[2].reload().then(function(data) {
                    if(data.dataset.itemsemparametrizacao[0]) {
                        widget.widgets[2].isVisible = true; 
                    }
                    else widget.widgets[2].isVisible = false; 
                });
            }
            
        }
        else {
            widget.widgets[2].isVisible = false; 
        }
    };
    
    this.openPreViewEnvio = function(widget) {
        var popup = widget.widgets[2];
        popup.currentRow.CDEMPRESA = widget.getParent().currentRow.CDEMPRESA;
        popup.currentRow.NMEMPRESA = widget.getParent().currentRow.NMEMPRESA;
        popup.isVisible = true;
        popup.activate();
        popup.currentRow.IDEVENTO = 'T';
        ScreenService.openPopup(popup);  
    };
    
    this.closePopupPreview = function(widget) {
        widget.isVisible = false;
        ScreenService.closePopup(widget);
        widget.getParent().activate();
    };
    
    this.previewRelatorio = function(widget) {
        if(widget.isValid()) {
            var currentRow = widget.currentRow;
            
            var reportName = 'PREVIEWREINF';
            var params = {
                "EMPRESA": currentRow.CDEMPRESA,
                "PERIODO": currentRow.DTMESCOMPETENC,
                "IDEVENTO": currentRow.IDEVENTO
            };
            
            General.openReport('fis#/previewEnvioReinf', reportName, params);
            ScreenService.closePopup();
        }  
    };
    
    this.limparBase = function(widget){
        ScreenService.confirmMessage(ScreenService.i18n('Deseja limpar a base de dados para o contribuinte informado?'), 'question', function (success) {
        
            General.callRestEngine('fis_acessorias#/limparBase','Row',widget.currentRow).then(
                function (response)  {
                    var message = '';
                    response.messages.forEach(function(objMessage) {
                        message += '<br>' + objMessage.message + '<br>';
                    });
                    if (message) {
                        ScreenService.showMessage(message);
                    }
                    ScreenService.closePopup();
                    templateManager.container.getWidget('widgetEnvioEventos').reload();
                    
                }.bind(this),
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );
        }, function(){
            ScreenService.closePopup();

        });
    };
    
};

Configuration(function(ContextRegister) { 
    ContextRegister.register("Fis75000_Efd_Reinf_Controller", Fis75000_Efd_Reinf_Controller);
});
